//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 4.1: Dynamische Datenstrukturen
//
// Datei:  Stack.h
// Inhalt: Stack mit Push-, Pop- und Ausgabe-Funktion
//////////////////////////////////////////////////////////////////////////////

#ifndef STACK_H_
#define STACK_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
using namespace std;
#include "Student.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// STRUCT DECLARATION /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// Stackstruktur
struct Stack
{

	Stack();
	void push(const Student& stud);
	void ausgabe();
	bool pop(Student& stud);
	struct ListElem
	{
		Student data; //d
		ListElem* next; //e
	};
	ListElem* head; //f
	ListElem* tail; //g
};


#endif /*STACK_H_*/
