//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 4.2: Dynamische Datenstrukturen
//
// Datei:  List.h
// Inhalt: Liste mit Methoden
//////////////////////////////////////////////////////////////////////////////

#ifndef LIST_H_
#define LIST_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
using namespace std;
#include "Student.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// STRUCT DECLARATION /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

struct List
{
  
	List();
	void enqueuehead(const Student& stud);	// vorne anfügen
	bool dequeue(Student& stud);			// hinten abhängen, wird nicht benötigt
	void ausgabevorwaerts();				// von vorne nach hinten ausgeben
	
	void ausgaberueckwaerts();				// von hinten nach vorne ausgeben
	bool eintragloeschen(int matrikelnummer);	// Eintrag suchen und löschen
	void enqueuetail(const Student& stud);	// hinten anfügen

	
	  
	struct ListElem{
		Student data;
		ListElem* next;	// zeigt auf das nächste Element (nach hinten)
		ListElem* prev;	// zeigt auf das vorherige Element (nach vorn)
	};
	
	ListElem* head;
	ListElem* tail;
};

#endif /*LIST_H_*/
