//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Gauss.h
// Inhalt: Gauss-Klasse
//////////////////////////////////////////////////////////////////////////////

#ifndef GAUSS_H_
#define GAUSS_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "LGSLoeser.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
class Gauss : public LGSLoeser
{
public:
	Gauss(int n);
	Vektor loese(QMatrix A, Vektor b);
	~Gauss();

private:
	void stufenForm(QMatrix& A, Vektor& b);
	void rueckwaertsEinsetzen(QMatrix& A, Vektor& b);

	Vektor* x;
};


#endif /*GAUSS_H_*/
