//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: Lsung eines mathematischen Anwendungsproblems
//
// Datei:  LGSLoeser.h
// Inhalt: Abstrakte Oberklasse LGSLoeser
//////////////////////////////////////////////////////////////////////////////

#ifndef LGSLOESER_H_
#define LGSLOESER_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "QMatrix.h"
#include "Vektor.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
 
// Abstrakte Oberklasse
class LGSLoeser
{
public:
	// Lsungsmethode, bernimmt Matrix A und Vektor b und gibt die Lsung x zurck
	virtual Vektor loese(QMatrix A, Vektor b)=0;
	
protected:
	Vektor* x;
};

#endif /*LGSLOESER_H_*/
