//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8.2: STL
//
// Datei:  Student.cpp
// Inhalt: Studentenklasse mit Merkmalen eines Studenten
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Student.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Konstruktor
Student::Student(int matrikelnummer, string name2, string vorname2, string datum):
	matNr(matrikelnummer), name(name2), vorname(vorname2), geburtsdatum(datum)
{
}

// gibt die Matrikelnummer zurück.
int Student::getMatNr() const
{
	return matNr;
}

// für die Ausgabe
ostream& Student::ausgabe(ostream& out)
{
	out << "\nMatrikelnummer:\t" << this->matNr
				<< "\nName:\t\t" << this->vorname <<" "<< this->name
				<< "\nGeburtsdatum:\t" << this->geburtsdatum << "\n";
	return out;
}

// Diverse Vergleichsoperatoren
bool operator == (const Student& stud1,const Student& stud2)
{
	if(stud1.matNr == stud2.matNr) return true;
	else return false;
}
bool operator < (const Student& stud1,const Student& stud2)
{
	if(stud1.matNr < stud2.matNr) return true;
	else return false;
}
bool operator > (const Student& stud1,const Student& stud2)
{
	if(stud1.matNr > stud2.matNr) return true;
	else return false;
}

// globaler Ausgabeoperator
ostream& operator << (ostream& out, Student& stud)
{
	out << stud.ausgabe(out);
	return out;
}
