//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8.2: STL
// Datei:  main.cpp
// Inhalt: Hauptprogramm
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include "Student.h"

using namespace std;

int main()
{
	Student stud1(22222, "Born"      ,"Jessica", "16.03.1986");
	Student stud2(24528, "Rodenstock","Max"    , "09.02.1985");
	Student stud3(95420, "Schneider" ,"Petra"  , "29.12.1989");
	Student stud4(44523, "Baumeister","Siggi"  , "13.01.1979");
	Student stud5(12635, "Baumeister","Dinah"  , "07.06.1982");
	Student stud6(81237, "Simoneit"  ,"Harro"  , "30.10.1973");
	Student stud7(54879, "Soers"     ,"Irmchen", "01.06.1983");
	Student stud8(35484, "West"      ,"Johnny" , "24.12.1980");
	
	// Container anlegen
	vector<Student> matrix;
	// Abkürzung für den Iteratortyp festlegen
	typedef vector<Student>::iterator iterTyp;

	// alle Studenten in die matrix pushen
	matrix.push_back(stud1);
	matrix.push_back(stud2);
	matrix.push_back(stud3);
	matrix.push_back(stud4);
	matrix.push_back(stud5);
	matrix.push_back(stud6);
	matrix.push_back(stud7);
	matrix.push_back(stud8);

	// matrix sortieren
	stable_sort(matrix.begin(), matrix.end(), greater<Student>());

	// matrix ausgeben
	for(iterTyp i = matrix.begin(); i != matrix.end(); i++)
	{
		cout << *i << endl;
	}

	// Eintrag suchen
	int such = 0;
	cout << "\nNach welcher MatNr suchen?\t";
	cin >> such;

	Student vergleicher(such, "", "", "");
	/* wird gebraucht, um die die Methode find benutzen zu können.
	 * Da der überladene Operator == nur die Matrikelnummern vergleicht,
	 * brauchen die drei Strings keine (sinnvollen) Werte zu besitzen.
	 */

	iterTyp found = find(matrix.begin(), matrix.end(), vergleicher);
	/* found zeigt jetzt auf das gefundene Element oder auf matrix.end().
	 * Im letzteren Fall konnte das Element nicht gefunden werden.
	 */

	if(found != matrix.end())
	{
		// Eintrag ausgeben
		cout << *found;

		cout << "\nSoll der Eintrag gelöscht werden?(j/n)\t";
		char input = 'n';
		cin >> input;
		if(input == 'j')
		{ // löschen
			matrix.erase(found);
		}

	}
	else cout << "Nicht gefunden." << endl;

	cout << "Erneute Ausgabe:\n";

	// matrix ausgeben
		for(iterTyp i = matrix.begin(); i != matrix.end(); i++)
		{
			cout << *i << endl;
		}
	return 0;
}
