#ifndef Vektor_H
#define Vektor_H

class Vektor
{
   public: //konstruktor/destruktor
      Vektor(double x, double y, double z);
      ~Vektor();

   private: //member
      double x;
      double y;
      double z;

   public:
      void ausgabe();
      double length(); // berechnet die Länge des Vektors

      double xComponent(); // geben die Einzelkomponenten des Vektors zurück.
      double yComponent();
      double zComponent();

      void subtract(Vektor v); // subtrahiert v von this.

      static Vektor add(Vektor a, Vektor b); // addiert a und b und erzeugt einen neuen Vektor.
      static Vektor rotate(Vektor v, double angle); //dreht den Vektor v um den Winkel angle.

};

#endif
