//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Cramer.h
// Inhalt: Cramer-Klasse
//////////////////////////////////////////////////////////////////////////////

#ifndef CRAMER_H_
#define CRAMER_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "LGSLoeser.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

class Cramer : public LGSLoeser
{
public:
	Cramer(int n);
	~Cramer();
	Vektor loese(QMatrix A, Vektor b);

private:
	// berechnet die Determinante von A.
	double determinante(QMatrix& A);
	// invertiert A.
	void invertiere(QMatrix& A);

	QMatrix* A_invers;
	Vektor* x;
};



#endif /*CRAMER_H_*/
