//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8.1: Sortierverfahren, Templates
//
// Datei:  Student.cpp
// Inhalt: Studentenklasse mit Merkmalen eines Studenten
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Student.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Konstruktor
Student::Student(int matrikelnummer, string name2, string vorname2, string gebdt):
	matNr(matrikelnummer), name(name2), vorname(vorname2), geburtsdatum(gebdt)
{
}

//////////////////////////////////////////////////////////////////////////////
// Gleichheitsoperator
bool Student::operator == (const Student& stud)
{
	if (matNr == stud.matNr)
		return true;
	else 
		return false;
}

//////////////////////////////////////////////////////////////////////////////
// Ordnungsrelation <
bool Student::operator < (const Student& stud)
{
	if (matNr < stud.matNr)
			return true;
		else
			return false;
}
//////////////////////////////////////////////////////////////////////////////
// Ordnungsrelation >
bool Student::operator > (const Student& stud)
{
	if (matNr > stud.matNr)
			return true;
		else
			return false;
}
//////////////////////////////////////////////////////////////////////////////
// Ordnungsrelation <=
bool Student::operator <= (const Student& stud)
{
	if (matNr <= stud.matNr)
			return true;
		else
			return false;
}
//////////////////////////////////////////////////////////////////////////////
// Ordnungsrelation >=
bool Student::operator >= (const Student& stud)
{
	if (matNr >= stud.matNr)
			return true;
		else
			return false;
}
///////////////////////////////////////////////////////////////////////////////
// Ausgabeoperator
ostream& operator << (ostream& out, Student& stud)
{
	out << "\nMatrikelnummer:\t" << stud.matNr
			<< "\nName:\t\t" << stud.vorname <<" "<< stud.name
			<< "\nGeburtsdatum:\t" << stud.geburtsdatum << "\n";
	return out;
}
