//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8.1: Sortierverfahren, Templates
//
// Datei:  Student.h
// Inhalt: Studentenklasse mit Merkmalen eines Studenten
//////////////////////////////////////////////////////////////////////////////

#ifndef STUDENT_H
#define STUDENT_H

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//StudentenKlasse
class Student
{
  public:
	Student(){}
	Student(int matrikelnummer, string name, string vorname, string geburtsdatum);
	bool operator == (const Student& stud);
	bool operator < (const Student& stud);
	bool operator > (const Student& stud);
	bool operator <= (const Student& stud);
	bool operator >= (const Student& stud);
	friend ostream& operator << (ostream& out, Student& stud);
	
  private:
	int matNr;
	string name;
	string vorname;
	string geburtsdatum;
};

#endif // STUDENT_H

